17 电话号码的字母组合
难度:中等
给定一个仅包含数字 2-9 的字符串,返回所有它能表示的字母组合。
给出数字到字母的映射如下(与电话按键相同)。注意 1 不对应任何字母。
示例:
输入:“23”
输出:[“ad”, “ae”, “af”, “bd”, “be”, “bf”, “cd”, “ce”, “cf”].
说明:
尽管上面的答案是按字典序排列的,但是你可以任意选择答案输出的顺序。
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/letter-combinations-of-a-phone-number
题解:用循环是不可解的,循环的层数由字符串的长度决定。因此想到可以用递归来解决。一个用来枚举字符串的长度,另一个用来枚举字符的可能性。开始的时候没有想到字符串的改变应该如何传递,用return实现也不可行,发现可以把它作为参数来使用,问题迎刃而解。当然,复杂度是最暴力的那一种。
class Solution {
public:
string a[10];
vector<string> res;
vector<string> letterCombinations(string digits) {
a[2] = "abc", a[3] = "def", a[4] = "ghi";
a[5] = "jkl", a[6] = "mno", a[7] = "pqrs";
a[8] = "tuv", a[9] = "wxyz";
if (digits.empty()) return res;
f(digits, 0, "");
return res;
}
void f(string digits, int i, const string& s) {
if (i == digits.size()){
res.push_back(s);
return;
}
int tmp = digits[i] - '0';
for (int j = 0; j < a[tmp].size(); j++) {
f(digits, i + 1, s + a[tmp][j]);
}
}
};
18 四数之和
难度:中等
给定一个包含 n 个整数的数组 nums 和一个目标值 target,判断 nums 中是否存在四个元素 a,b,c 和 d ,使得 a + b + c + d 的值与 target 相等?找出所有满足条件且不重复的四元组。
注意:
答案中不可以包含重复的四元组。
示例:
给定数组 nums = [1, 0, -1, 0, -2, 2],和 target = 0。
满足要求的四元组集合为:
[
[-1, 0, 0, 1],
[-2, -1, 1, 2],
[-2, 0, 0, 2]
]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/4sum
题解:两数之和,三数之和,三数之和接近,现在是四数之和。。。其实都是一样的,统统都是双指针。之前是枚举一层,剩下两个参数用双指针,现在是枚举两层,剩下两个参数用双指针。只是注意,四个数字在枚举的时候都要考虑重复元素的问题。
class Solution {
public:
vector<vector<int>> fourSum(vector<int>& nums, int target) {
vector<vector<int>> ans;
if (nums.size() < 4) return ans;
sort(nums.begin(), nums.end());
for (int i = 0; i < nums.size() - 3; i++) {
if (i != 0 && nums[i] == nums[i - 1]) continue;
for (int j = i + 1; j < nums.size() - 2; j++) {
if (j != i + 1 && nums[j] == nums[j - 1]) continue;
int k = target - (nums[i] + nums[j]);
int l = j + 1, r = nums.size() - 1;
while(l < r) {
if (l != j + 1 && nums[l] == nums[l - 1]){
l++;
continue;
}
if (r != nums.size() - 1 && nums[r] == nums[r + 1]){
r--;
continue;
}
if (nums[l] + nums[r] == k) {
ans.push_back({nums[i], nums[j], nums[l], nums[r]});
l++;
}
else if (nums[l] + nums[r] < k) {
l++;
}
else r--;
}
}
}
return ans;
}
};